#----------------------------------------------------------------------------
#
#   MatSheet - Application
#
#----------------------------------------------------------------------------

from GUI import Application, Window
from GUI.StdMenus import basic_menus
from sheetdoc import SheetDoc, mash_type
from sheetview import SheetView

edit_menu_items = [
    "-",
    ("Insert Row/I", 'insert_row_cmd'),
    ("Insert Column/@I", 'insert_column_cmd'),
    ("Delete Row/D", 'delete_row_cmd'),
    ("Delete Column/@D", 'delete_column_cmd'),
    "-",
    ("Edit Layout/L", 'edit_layout_cmd'),
]

class MatSheetApp(Application):

    def __init__(self):
        Application.__init__(self, title = "MatSheet")
        self.file_type = mash_type
        menus = basic_menus()
        menus.menu_with_command('copy_cmd').extend(edit_menu_items)
        self.menus = menus
    
    def open_app(self):
        self.new_cmd()

    def make_document(self, fileref):
        return SheetDoc()

    def make_window(self, doc):
        win = Window(size = (400, 400), document = doc)
        view = SheetView(model = doc, scrolling = 'hv')
        win.place(view, left = 0, top = 0, right = 0, bottom = 0, anchor = 'ltrb')
        view.become_target()
        win.show()
